/*
 * joymidi de tTh - sortie par ALSA
 */

#include  <stdio.h>
#include  <stdlib.h>
#include  <alsa/asoundlib.h>

#include  "contexte.h"
#include  "alsa_out.h"

/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
/*	private variables of this module */

static snd_seq_t	*alsa_hand;
static snd_seq_event_t	alsa_ev;
static int		midichannel;

/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
int open_alsa_out(char *name, int k)
{
int		foo;
snd_seq_addr_t	src;			/* this name sux */
char		chaine[T_LINE_CTX+1], *cptr;

#if DEBUG_LEVEL
fprintf(stderr, ">>>> %s (( '%s' , %d ))\n", __func__, name, k);
#endif

if (k > 0)
	{
#if DEBUG_LEVEL
	fprintf(stderr, "   using %d as midi channel\n", k);
#endif
	midichannel = k;
	}
else	
	{
	get_context("midichannel", chaine);
	fprintf(stderr, "[%s]\n", chaine);
	midichannel = strtol(chaine, &cptr, 0);
	}
midichannel -= 1;	/* internally 0 based */
fprintf(stderr, "internal midichannel is %d\n", midichannel);

if (snd_seq_open(&alsa_hand, "default", SND_SEQ_OPEN_OUTPUT, 0) < 0)
	{
	fprintf(stderr, "Fail on access to ALSA seq for '%s'\n", name);
	exit(3);
	}

#if DEBUG_LEVEL
fprintf(stderr, "     alsa seq handle at %p\n", alsa_hand);
#endif

foo = snd_seq_set_client_name(alsa_hand, name);
#if DEBUG_LEVEL
fprintf(stderr, "     set client name -> %d\n", foo);
#endif

src.client = snd_seq_client_id(alsa_hand);
src.port = snd_seq_create_simple_port(alsa_hand, "tth was here !",
		SND_SEQ_PORT_CAP_READ | SND_SEQ_PORT_CAP_SUBS_READ,
		SND_SEQ_PORT_TYPE_APPLICATION);

#if DEBUG_LEVEL
fprintf(stderr, "     client id %d, port %d\n", src.client, src.port);
#endif

snd_seq_ev_clear(&alsa_ev);
snd_seq_ev_set_source(&alsa_ev, src.port);
snd_seq_ev_set_subs(&alsa_ev);
snd_seq_ev_set_direct(&alsa_ev);

#if DEBUG_LEVEL
fprintf(stderr, "     %s done\n", __func__);
#endif

return -1;
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
int send_alsa_note_on(int note, int level)
{

#if DEBUG_LEVEL
fprintf(stderr, ">>>> %s (( %d , %d ))\n", __func__, note, level);
#endif

snd_seq_ev_set_noteon(&alsa_ev, midichannel, note, level);
snd_seq_event_output_direct(alsa_hand, &alsa_ev);

return -1;
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
int send_alsa_note_off(int note)
{
#if DEBUG_LEVEL
fprintf(stderr, ">>>> %s (( %d ))\n", __func__, note);
#endif
snd_seq_ev_set_noteoff(&alsa_ev, midichannel, note, 0);
snd_seq_event_output_direct(alsa_hand, &alsa_ev);
return -1;
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
int send_alsa_control(int ctrl, int value)
{

return -1;
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
/* to be used for box initialisations ? */
int send_alsa_bytes(unsigned char *buffer, int nbre)
{
int		foo;
#if DEBUG_LEVEL
fprintf(stderr, ">>>> %s (( %p %d ))\n", __func__, buffer, nbre);
#endif

/********** bon, comment on fait ? **********/
for (foo=0; foo<nbre; foo++)
	printf(">%02x ", buffer[foo]);
puts("");

return -1;
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
int send_alsa_pgm_change(int newpgm)
{
#if DEBUG_LEVEL
fprintf(stderr, ">>>> %s (( %d ))\n", __func__, newpgm);
#endif


return -1;
}
