
#include  <stdio.h>
#include  <stdlib.h>
#include  <unistd.h>
#include  <string.h>

#include  "contexte.h"

static char *location = NULL;

/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
/*
 * if request is NULL or request is an empty string, we build the
 * context path from $HOME and a predefined subpath.
 */
int	init_context(char *request)
{
char	*home;
char	*path;

#if DEBUG_LEVEL
fprintf(stderr, ">>>> %s (( '%s' ))\n", __func__, request);
#endif

if ((NULL==request) || ('\0'==request[0]))
	{
	/* we have to get the home directory ... */
	home = getenv("HOME");
	if (NULL == home)
		{
		fprintf(stderr, "%s : no HOME found, aborting.\n", __func__);
		abort();
		}
	/* ... and build the real path */
	location = malloc(strlen(home)+200);		/* coredump */
	strcpy(location, home);
	strcat(location, "/.tth/joymidi/");
	}
else
	{
	fprintf(stderr, "%s : requested location is '%s'\n",
						__func__, request);
	location = malloc(strlen(request)+1);
	strcpy(location, request);
	}

if ('/' != location[strlen(location)-1])
	{
#if DEBUG_LEVEL
	fprintf(stderr, "adding a '/' to %p\n", location);
#endif
	strcat(location, "/");
	}
#if DEBUG_LEVEL
fprintf(stderr, "     location of context is '%s'\n", location);
#endif

/* we check if the master file was here */
path = malloc(strlen(location)+42);
strcpy(path, location);
strcat(path, "context.init");		/* XXX harcoded filename ? */

#if DEBUG_LEVEL
fprintf(stderr, "     master file : '%s'\n", path);
#endif
if (access(path, R_OK))
	{
	perror(path);
	exit(1);
	}
free(path);			/* release temporary buffer */

return 0;
}

/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
char * where_is_dotrc(void)
{
#if DEBUG_LEVEL
fprintf(stderr, ">>>> %s\n", __func__);
#endif

if (NULL==location)
	{
	fprintf(stderr, "something wrong happens in %s\n", __func__);
	abort();
	}

#if DEBUG_LEVEL
fprintf(stderr, "     dotrc dir is '%s'\n", location);
#endif

return location;
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
/* return 0 if not found, 1 if found, and (maybe) -1 on error */

int get_context(char *name, char *where)
{
char		chemin[T_LINE_CTX+1];
FILE		*fp;
char		ligne[T_LINE_CTX+1], *pkey, *pval;
int		found;

if (NULL == location)
	{
	fprintf(stderr, "nasty bug in '%s' : location is NULL\n", __func__);
	exit(1);
	}
strcpy(chemin, location);
strcat(chemin, "context.init");
#if DEBUG_LEVEL
fprintf(stderr, "getting '%s' from '%s'\n", name, chemin);
#endif

if (NULL==(fp=fopen(chemin, "r")))
	{
	fprintf(stderr, "%s : can not open %s\n", __func__, chemin);
	return 0;
	}

found = 0;
while (NULL!=fgets(ligne, T_LINE_CTX, fp))
	{
	if (strlen(ligne) && ligne[strlen(ligne)-1]=='\n')
		ligne[strlen(ligne)-1]='\0';

#if DEBUG_LEVEL > 1
	printf("line is [%s]\n", ligne);
#endif
	pkey = strtok(ligne, " \t");
#if DEBUG_LEVEL > 1
	printf("key is [%s]\n", pkey);
#endif
	if (NULL==pkey)
		{
		/* this is an empty line */
		continue;
		}
	if ('#' == pkey[0])
		{
		/* this is a comment */
		continue;
		}
	pval = strtok(NULL, " \t");
#if DEBUG_LEVEL > 1
	printf("value is [%s]\n", pval);
#endif
	if ( ! strcmp(pkey, name) )
		{
		printf("found '%s' --> '%s'\n", name, pval);
		strncpy(where, pval, T_LINE_CTX);
		found = 1;
		}
	}

fclose(fp);

return found;
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
