/*
 * dump_my_joy.c 
 */

#include  <stdio.h>
#include  <stdlib.h>
#include  <unistd.h>
#include  <string.h>
#include  <fcntl.h>
#include  <linux/joystick.h>

#include  "contexte.h"
#include  "jmidi.h"

/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
void help(int k)
{
fprintf(stderr, 
	"dump_my_joy options:\n"
	"  -v : increment verbose level\n"
	"  -h : get more help (if available)\n"
	"  -i : set the locations of init files\n"
	"  -d : use an alternate joy device\n"
	"  -n : display just the numbers\n");
exit(1);
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
int main(int argc, char *argv[])
{
int			fd, foo, bar;
struct js_event		evn;
char			joydevice[T_LINE_CTX+1];
char			initlocation[T_LINE_CTX+1];
char			pathname[T_LINE_CTX+1];
char			*cptr, buffer[100];
int			numeric, verbose;
char			options[] = "vhnd:i:";

/* initialising some default values */
numeric = verbose = 0;
joydevice[0] = '\0';
initlocation[0] = '\0';

/* exploration of the command line arguments */
while ((foo = getopt(argc, argv, options)) != -1)
	{
	switch(foo) {
	case 'v':
		verbose++;
		break;
	case 'h':
		help(1);
		break;
	case 'n':
		numeric = 1;
		break;
	case 'd':
		strncpy(joydevice, optarg, T_LINE_CTX);
		break;
	case 'i':
		strncpy(initlocation, optarg, T_LINE_CTX);
		fprintf(stderr, "* init files in '%s'\n", initlocation);
		break;
	default:
		help(0);
		break;
		}
#if DEBUG_LEVEL > 1
	fprintf(stderr, "opt '%c' -> %d\n", foo, optind);
#endif
	}

printf("========== dump my joy == (%s, %s) ========\n", __DATE__, __TIME__);

/* initialising the thing with the standard context */
foo = init_context(initlocation);
foo = get_context("buttonsnames", pathname);
if (foo)
	{
	fprintf(stderr, "loading buttons name from '%s'\n", pathname);
	foo = load_buttons_names(pathname);
	}
#if DEBUG_LEVEL
fprintf(stderr, "chargement config boutons -> %d\n", foo);
dump_buttons_names();
#endif

if ('\0' == joydevice[0])
	{
	if ( ! get_context("joydevice", joydevice) )
		{
		fprintf(stderr, "nasty context file\n");
		exit(1);
		}
	}
else
	{
	printf("trying to read device '%s'\n", joydevice);
	}

fd = open(joydevice, O_RDONLY);
if (fd < 0)
	{
	perror(joydevice);
	exit(1);
	}
#if DEBUG_LEVEL
fprintf(stderr, "ouverture manette '%s' --> %d\n", joydevice, fd);
#endif

/*
 * and now, we enter the big eternal loop...
 */
for (bar=0;;)
	{
	foo = read(fd, &evn, sizeof(evn));
	/* no check of error on the read ? FIXME */
#if DEBUG_LEVEL
	fprintf(stderr, "read %d bytes from fd %d\n", foo, fd);
#endif

	if (numeric)
		{
		if ( ! ((bar++)%20) )
			puts("      time      type     numbt        value");

		printf("%12d       %3u    %3u      %6d\n",
				evn.time, evn.type,
				evn.number, evn.value);
		}
	else
		{
		if ( NULL==(cptr=lookup_button_name(evn.number, evn.type)) )
			{
			sprintf(buffer, "# %-3d  ", evn.number);
			cptr = buffer;
			}

		printf("%12d:   %-12s    %-18s     ",
				evn.time, jsevent2text(evn.type),
				cptr);
		if ( ! (evn.type & JS_EVENT_INIT) )
			{
			if (evn.type==JS_EVENT_BUTTON)
				printf("note %s\n", evn.value ? "on" : "off");
			else
				printf("v = %d\n", evn.value);
			}
		else
			{
			printf("init value  %d\n", evn.value);
			}
		}
	}


return 0;
}

/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */

