/*
 * init_box.c - preparing the MIDI toy for the show !
 */

#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <unistd.h>
#include  <fcntl.h>

#include  "midi_out.h"
#include  "alsa_out.h"
#include  "init_box.h"

/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
/* EXPERIMENTAL */
int send_simpleascii_2_midi(char *fname, int midi, int k)
{
FILE		*fp;
char		ligne[500+1], *cptr, *cptr2;
#define NBR_OCTETS 100
unsigned char	octets[NBR_OCTETS];
int		foo, idx;
long		lvalue;

#if DEBUG_LEVEL
fprintf(stderr, ">>>> %s (( '%s' %d %d ))\n", __func__,
					fname, midi, k);
#endif

if (NULL==(fp=fopen(fname, "r")))
	{
	fprintf(stderr, "%s : can't open '%s'\n", __func__, fname);
	return -1;
	}

while (NULL!=fgets(ligne, 500, fp))
	{
	if (strlen(ligne) && ligne[strlen(ligne)-1]=='\n')
		ligne[strlen(ligne)-1]='\0';
	else
		{
		fprintf(stderr, "%s : line too long\n", fname);
		exit(1);
		}
#if DEBUG_LEVEL
	fprintf(stderr, "line is [%s]\n", ligne);
#endif

	cptr = strtok(ligne, " \t");
#if DEBUG_LEVEL
	fprintf(stderr, "  1st token [%s]\n", cptr);
#endif

	if (NULL == cptr)			/* empty line */
		continue;
	if ('#' == cptr[0])			/* comment line */
		continue;

	/* here is the place where we can read some keywords */
	if (!strcmp("debug", cptr))
		{
		/* this is fully bugged !
                   where is the complete end of the line ? */
		fprintf(stderr, "*** %s\n", ligne);
		continue;
		}

	/* and now, try to scan a line of valid numbers */
	idx = 0;
	do
		{
		lvalue = strtol(cptr, &cptr2, 0);
#if DEBUG_LEVEL
		fprintf(stderr, " token [%s] -> %ld\n", cptr, lvalue);
#endif
		if (cptr==cptr2)
			{
			fprintf(stderr, "'%s' is not an lvalue\n", cptr);
			return -1;
			}
		if (lvalue<0 || lvalue>256)
			{
			fprintf(stderr, "%ld is not a byte\n", lvalue);
			return -1;
			}

		octets[idx] = (unsigned char)lvalue;
		if (++idx > NBR_OCTETS)
			{
			fprintf(stderr, "to much bytes\n");
			return -1;
			}

		} while ( (cptr=strtok(NULL, " \t")) );

#if DEBUG_LEVEL
	for (foo=0; foo<idx; foo++)
		fprintf(stderr, "%02x ", octets[foo]);
	fprintf(stderr, "\n");
#endif

	/* OK, got all the good bytes, blast them to the box */
	send_alsa_bytes(octets, idx);
	
	}

return 0;
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
/* EXPERIMENTAL */
int send_binary_2_midi(char *fname, int midi, int k)
{

#if DEBUG_LEVEL
fprintf(stderr, ">>>> %s (( '%s' %d %d ))\n", __func__,
					fname, midi, k);
#endif

return -1;
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */

